from sokoenginepy import AtomicMove, Direction, Tessellation

from ..test_helpers import TessellationSpecMixin
from .autogenerated_tessellation import \
    SokobanTessellationAutogeneratedSpecMixin


class DescribeSokobanTessellation(
    TessellationSpecMixin, SokobanTessellationAutogeneratedSpecMixin
):

    illegal_directions = [
        Direction.NORTH_WEST, Direction.NORTH_EAST, Direction.SOUTH_WEST,
        Direction.SOUTH_EAST
    ]

    legal_directions = [
        Direction.LEFT, Direction.RIGHT, Direction.UP, Direction.DOWN
    ]

    legal_moves = [
        AtomicMove(Direction.LEFT, False),
        AtomicMove(Direction.RIGHT, False),
        AtomicMove(Direction.UP, False),
        AtomicMove(Direction.DOWN, False),
        AtomicMove(Direction.LEFT, True),
        AtomicMove(Direction.RIGHT, True),
        AtomicMove(Direction.UP, True),
        AtomicMove(Direction.DOWN, True),
    ]

    legal_characters = ['l', 'r', 'u', 'd', 'L', 'R', 'U', 'D']

    tessellation = Tessellation.instance_from('Sokoban').value
